package com.gic.haoban.manage.service.service.impl;

import java.util.Date;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.gic.commons.util.EntityUtil;
import com.gic.haoban.base.api.common.BasePageInfo;
import com.gic.haoban.common.utils.StringUtil;
import com.gic.haoban.manage.api.dto.MemberUnionidRelatedDTO;
import com.gic.haoban.manage.service.dao.mapper.MemberUnionidRelatedMapper;
import com.gic.haoban.manage.service.entity.MemberUnionidRelated;
import com.gic.haoban.manage.service.service.MemberUnionRelatedService;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;

@Service
public class MemberUnionRelatedServiceImpl implements MemberUnionRelatedService {

	@Autowired
	private MemberUnionidRelatedMapper mapper;
	
	@Override
	public MemberUnionidRelatedDTO getByWxUserIdAndUnionId(String wxEnterpriseId, String staffId, String unionid) {
		return EntityUtil.changeEntityByJSON(MemberUnionidRelatedDTO.class, mapper.getByUnionId(wxEnterpriseId, staffId, unionid));
	}
	
	@Override
	public String addMemberUnionidRelated(MemberUnionidRelatedDTO dto) {
		dto.setStatusFlag(1);
		dto.setCreateTime(new Date());
		dto.setUpdateTime(new Date());
		dto.setMemberUnionidRelatedId(StringUtil.randomUUID());
		mapper.insert(EntityUtil.changeEntityByJSON(MemberUnionidRelated.class, dto));
		return dto.getMemberUnionidRelatedId();
	}

	@Override
	public void delMemberUnionidRelated(MemberUnionidRelatedDTO dto , String staffId) {
		mapper.deleteByUnionidAndUserId(dto.getExternalUserid(),staffId);
	}

	@Override
	public void delMemberUnionidRelatedBatch(String wxEnterpriseId, String staffId, List<String> externalUserids) {
		mapper.delMemberUnionidRelatedBatch(wxEnterpriseId, externalUserids, staffId);
	}

	@Override
	public void update(MemberUnionidRelatedDTO exsitDTO) {
        exsitDTO.setUpdateTime(new Date());
        mapper.updateByPrimaryKeySelective(EntityUtil.changeEntityByJSON(MemberUnionidRelated.class, exsitDTO));
	}

	@Override
	public void clean(String cid) {
		mapper.cleanByCid(cid);
	}

	@Override
	public void cleanStaffRelated(String wxEnterpriseId, List<String> staffIds) {
		if(staffIds == null || staffIds.isEmpty()){
			return;
		}
		mapper.cleanStaffRelated(wxEnterpriseId,staffIds);
	}

	@Override
	public MemberUnionidRelatedDTO getByWxUserIdAndSelfExternalUserId(String staffId, String wxEnterpriseId, String selfExternalUserId) {
		MemberUnionidRelated unionidRelated = mapper.getBySelfExternalUserId(staffId,wxEnterpriseId, selfExternalUserId);
		return EntityUtil.changeEntityNew(MemberUnionidRelatedDTO.class, unionidRelated);
	}

	@Override
	public MemberUnionidRelatedDTO getBySelfExternalUserId(String wxEnterpriseId, String selfExternalUserId) {
		MemberUnionidRelated unionidRelated = mapper.getBySelfExternalUserId(null,wxEnterpriseId, selfExternalUserId);
		return EntityUtil.changeEntityNew(MemberUnionidRelatedDTO.class, unionidRelated);
	}

	@Override
	public List<MemberUnionidRelatedDTO> listBySelfExternalUserId(String staffId, String wxEnterpriseId, String selfExternalUserId) {
		List<MemberUnionidRelated> retList = mapper.listBySelfExternalUserId(staffId, wxEnterpriseId, selfExternalUserId);
		return EntityUtil.changeEntityListNew(MemberUnionidRelatedDTO.class, retList);
	}

	@Override
	public int updateExternalUseridByWxEnterpriseId(String wxEnterpriseId) {
		return mapper.updateExternalUseridByWxEnterpriseId(wxEnterpriseId);
	}

	@Override
	public PageInfo<MemberUnionidRelated> listByWxEnterpriseId(String wxEnterpriseId, BasePageInfo basePageInfo) {
		PageHelper.startPage(basePageInfo);
		List<MemberUnionidRelated> memberUnionidRelateds = mapper.listByWxEnterpriseId(wxEnterpriseId);
		return new PageInfo<>(memberUnionidRelateds);
	}
}
